/*
    Copyright 2009 Graham King <graham@gkgk.org>

    This file is part of Foxden.

    Foxden is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Foxden is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foxden.  If not, see <http://www.gnu.org/licenses/>.
*/

var FDO = {
        
    populateMenu:
        function() {

            var menu = document.getElementById('foxden_popup');
            while (menu.firstChild) {
                menu.removeChild(menu.firstChild);
            }

            var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefService);
                          
            FDO._upgradeFromPreviousVersion(prefs);

            var branch = prefs.getBranch("extensions.foxden.layout.");
            var prefTree = branch.getChildList("", {});
            
            prefTree.forEach(
                     function(prefName, index, arr) {
                        var prefParts = prefName.split('.');
                        if (prefParts[1] == 'name') {
                            var friendlyName = branch.getCharPref(prefName);
                            FDO._addMenuItem(prefParts[0], friendlyName);
                        }

                     }
            );

            menu.appendChild( document.createElement('menuseparator') );
            
            var config = document.createElement('menuitem');
            config.setAttribute('label', 'Configure...');
            config.addEventListener('command', FDO.openConfig, false);
            menu.appendChild(config);
        },
        
    _upgradeFromPreviousVersion:
        function(prefs) {
            
            var foxdenBranch = prefs.getBranch('extensions.foxden.');
            var oldDefaultLayout = null;
            var newDefaultLayout = null;
            try {
                oldDefaultLayout= foxdenBranch.getCharPref('layout');
                newDefaultLayout = foxdenBranch.getCharPref('layout.default.layout');
            }
            catch (e) {}
            
            if (oldDefaultLayout && ! newDefaultLayout) {
                //dump('converted\n');
                foxdenBranch.setCharPref('layout.default.name', 'Your previous layout');
                foxdenBranch.setCharPref('layout.default.layout', oldDefaultLayout);
            }
            
        },
        
    _addMenuItem:
        function(slug, label) {
            var item = document.createElement('menuitem');
            item.setAttribute('label', label);
            item.setAttribute('id', slug);
            item.addEventListener('command',
                                  function() { FDO.openMainWindow(slug) },
                                  false);
            
            var menu = document.getElementById('foxden_popup');
            menu.appendChild(item);
        },
        
    openConfig:
        function() {
            openDialog("chrome://foxden/content/config.xul", "foxden_config");
        },
        
    openMainWindow:
        function(slug) {
    
            // Pass the layout name via a preference
            var prefs = Components.classes["@mozilla.org/preferences-service;1"]
                          .getService(Components.interfaces.nsIPrefService);            
            var branch = prefs.getBranch("extensions.foxden.");
            branch.setCharPref('now_opening', slug);
            
            open("chrome://foxden/content/foxden.xul",
                 "Foxden_"+ slug,
                 "chrome,resizable=yes");
    }

}